#include <iostream>
#include <ctime>
#include <pthread.h>

int const arrSize = 20;
//для обмена информацией между потоками
//первый поток записывает результат в М0, второй в М1
int M0; 
int M1;

pthread_barrier_t barr ; //барьер
pthread_t mythread ;  //идентификатор для дочернего потока

pthread_mutex_t mutex ; // мьютекс для синхронизации вывода

// Генератор массива
void RndArray (int *A, int size) {
    for(int i = 0; i < size; i++) {
        A[i] = rand() % 3 + 1;
    }
}

// Вывод массива
void OutArray (int *A, int size) {
    for(int i = 0; i < size; i++) {
        std::cout << A[i] << "   ";
    }
    std:: cout << "\n";
}

//стартовая функция
void* func(void *param) {
    int p = *((int*)param);
    int Array[arrSize] ; //собственный массив потока
    RndArray(Array, arrSize);   // инициализация числами от 1 до 3

    // Согласование вывода данных
    pthread_mutex_lock(&mutex) ; //защита операции записи
    // Вывод результатов
    std::cout << "Source array. Thread " << p << ": ";
    OutArray(Array, arrSize);
    //конец критической секции
    pthread_mutex_unlock(&mutex);

    for (int i=0 ; i<arrSize ; i++) {
        pthread_barrier_wait(&barr) ; //ожидание на барьере
        //первый поток записывает элемент массива в М0, второй в М1
        if (p == 0 ) {
            M0=Array[i] ;
        }
        if (p == 1 ) {
            M1=Array[i] ;
        }
        pthread_barrier_wait(&barr) ; //ожидание на барьере
        //если соответственные элементы массивов равны, заменим их нулями
        if (M0 == M1) {
            Array[i]=0 ;
        }
        ///pthread_barrier_wait(&barr) ; //ожидание на барьере
    }

    // Согласование вывода данных
    pthread_mutex_lock(&mutex) ; //защита операции записи
    // Вывод результатов
    std::cout << "Result array. Thread " << p << ": ";
    OutArray(Array, arrSize);
    //конец критической секции
    pthread_mutex_unlock(&mutex);
    
    return nullptr;
}

int main() {
    int zero = 0;
    int one  = 1;
    
    auto seed = clock(); //101;
    srand(seed);

    pthread_mutex_init(&mutex, nullptr) ; 

    pthread_barrier_init(&barr, nullptr, 2) ; //инициализация барьера со значением 2
    pthread_create(&mythread, nullptr, func, (void *)&zero) ; //создание дочернего потока
    func((void *)&one) ; 
    
    pthread_join(mythread, nullptr);
    return 0;
}
